/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.deepexi.scd.calculate.mq.producer.RocketMQProducer
 *  com.deepexi.scd.common.properties.CustomRocketMQProperties
 *  com.deepexi.scd.common.properties.CustomRocketMQProperties$Producer
 *  com.deepexi.scd.common.system.AppRuntimeEnv
 *  org.apache.rocketmq.client.AccessChannel
 *  org.apache.rocketmq.client.MQAdmin
 *  org.apache.rocketmq.client.producer.DefaultMQProducer
 *  org.apache.rocketmq.spring.core.RocketMQTemplate
 *  org.apache.rocketmq.spring.support.RocketMQMessageConverter
 *  org.apache.rocketmq.spring.support.RocketMQUtil
 *  org.springframework.beans.factory.annotation.Autowired
 *  org.springframework.boot.autoconfigure.condition.ConditionalOnBean
 *  org.springframework.boot.autoconfigure.condition.ConditionalOnClass
 *  org.springframework.boot.autoconfigure.condition.ConditionalOnMissingBean
 *  org.springframework.boot.autoconfigure.condition.ConditionalOnProperty
 *  org.springframework.boot.context.properties.EnableConfigurationProperties
 *  org.springframework.context.annotation.Bean
 *  org.springframework.context.annotation.Configuration
 *  org.springframework.core.env.Environment
 *  org.springframework.util.Assert
 *  org.springframework.util.StringUtils
 */
package com.deepexi.scd.calculate.config;

import com.deepexi.scd.calculate.mq.producer.RocketMQProducer;
import com.deepexi.scd.common.properties.CustomRocketMQProperties;
import com.deepexi.scd.common.system.AppRuntimeEnv;
import javax.annotation.PostConstruct;
import org.apache.rocketmq.client.AccessChannel;
import org.apache.rocketmq.client.MQAdmin;
import org.apache.rocketmq.client.producer.DefaultMQProducer;
import org.apache.rocketmq.spring.core.RocketMQTemplate;
import org.apache.rocketmq.spring.support.RocketMQMessageConverter;
import org.apache.rocketmq.spring.support.RocketMQUtil;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.condition.ConditionalOnBean;
import org.springframework.boot.autoconfigure.condition.ConditionalOnClass;
import org.springframework.boot.autoconfigure.condition.ConditionalOnMissingBean;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.boot.context.properties.EnableConfigurationProperties;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.core.env.Environment;
import org.springframework.util.Assert;
import org.springframework.util.StringUtils;

@Configuration
@EnableConfigurationProperties(value={CustomRocketMQProperties.class})
@ConditionalOnClass(value={MQAdmin.class})
@ConditionalOnProperty(prefix="deepexi.scd.rocketmq", value={"enable"}, havingValue="true", matchIfMissing=true)
public class CustomRocketMQAutoConfiguration {
    private static final Logger log = LoggerFactory.getLogger(CustomRocketMQAutoConfiguration.class);
    public static final String ROCKETMQ_TEMPLATE_DEFAULT_GLOBAL_NAME = "rocketMQTemplate";
    @Autowired
    private Environment environment;

    @PostConstruct
    public void checkProperties() {
        String nameServer = (String)this.environment.getProperty("deepexi.scd.rocketmq.name-server", String.class);
        log.debug("deepexi.scd.rocketmq.nameServer = {}", (Object)nameServer);
        if (nameServer == null) {
            log.warn("The necessary spring property 'rocketmq.name-server' is not defined, all rockertmq beans creation are skipped!");
        }
    }

    @Bean
    @ConditionalOnMissingBean(value={DefaultMQProducer.class})
    @ConditionalOnProperty(prefix="deepexi.scd.rocketmq", value={"name-server", "producer.group"})
    public DefaultMQProducer defaultMQProducer(CustomRocketMQProperties rocketMQProperties) {
        CustomRocketMQProperties.Producer producerConfig = rocketMQProperties.getProducer();
        String nameServer = rocketMQProperties.getNameServer();
        String groupName = producerConfig.getGroup();
        Assert.hasText((String)nameServer, (String)"[rocketmq.name-server] must not be null");
        Assert.hasText((String)groupName, (String)"[rocketmq.producer.group] must not be null");
        String accessChannel = rocketMQProperties.getAccessChannel();
        String ak = rocketMQProperties.getProducer().getAccessKey();
        String sk = rocketMQProperties.getProducer().getSecretKey();
        boolean isEnableMsgTrace = rocketMQProperties.getProducer().isEnableMsgTrace();
        String customizedTraceTopic = rocketMQProperties.getProducer().getCustomizedTraceTopic();
        DefaultMQProducer producer = RocketMQUtil.createDefaultMQProducer((String)groupName, (String)ak, (String)sk, (boolean)isEnableMsgTrace, (String)customizedTraceTopic);
        producer.setNamesrvAddr(nameServer);
        if (!StringUtils.isEmpty((Object)accessChannel)) {
            producer.setAccessChannel(AccessChannel.valueOf((String)accessChannel));
        }
        producer.setSendMsgTimeout(producerConfig.getSendMessageTimeout());
        producer.setRetryTimesWhenSendFailed(producerConfig.getRetryTimesWhenSendFailed());
        producer.setRetryTimesWhenSendAsyncFailed(producerConfig.getRetryTimesWhenSendAsyncFailed());
        producer.setMaxMessageSize(producerConfig.getMaxMessageSize());
        producer.setCompressMsgBodyOverHowmuch(producerConfig.getCompressMessageBodyThreshold());
        producer.setRetryAnotherBrokerWhenNotStoreOK(producerConfig.isRetryNextServer());
        return producer;
    }

    @Bean(destroyMethod="destroy")
    @ConditionalOnBean(value={DefaultMQProducer.class})
    @ConditionalOnMissingBean(name={"rocketMQTemplate"})
    public RocketMQTemplate rocketMQTemplate(DefaultMQProducer mqProducer, RocketMQMessageConverter rocketMQMessageConverter) {
        RocketMQTemplate rocketMQTemplate = new RocketMQTemplate();
        rocketMQTemplate.setProducer(mqProducer);
        rocketMQTemplate.setMessageConverter(rocketMQMessageConverter.getMessageConverter());
        return rocketMQTemplate;
    }

    @Bean
    public RocketMQProducer rocketMQProducer(AppRuntimeEnv appRuntimeEnv, DefaultMQProducer defaultMQProducer) {
        return new RocketMQProducer(defaultMQProducer, appRuntimeEnv);
    }
}

